<?php
/**
 * kpax helper functions
 * 
 * fichero copiado de kpax/lib/kpax.php
 * @package kpax
 */

/**
 * Prepare the add/edit form variables
 *
 * @param ElggObject $kpax A kpax object, as se ha definido en elgg, no 
 vale de nada renombrar. 
 *'subtypes' => 'kpax','subtypes' => 'kpax'
 * @return array
 */
function gameserver_prepare_form_vars($kpax = null) {
	// input names => defaults
	$values = array(
		'title' => get_input('title', ''), // bookmarklet support
		'description' => get_input('description', ''),
		'access_id' => ACCESS_PRIVATE,    //inicialmente  ACCESS_LOGGED_IN, MAS tarde cambiar a ACCESS_PRIVATE 
		'tags' => '',
		'shares' => array(),
		'container_guid' => elgg_get_page_owner_guid(),
		'guid' => null,
		'entity' => $kpax,
		'category' => get_input('category', '1'), //NOU
		'platform' => get_input('platform', '1'), //NOU
		'creationDate' => get_input('category', date("d-m-Y H:i:s")) //NOU
	);

	if ($kpax) {
		foreach (array_keys($values) as $field) {
			if (isset($kpax->$field)) {
				$values[$field] = $kpax->$field;
			}
		}
	}

	if (elgg_is_sticky_form('gameserver')) {
		$sticky_values = elgg_get_sticky_values('kpax');
		foreach ($sticky_values as $key => $value) {
			$values[$key] = $value;
		}
	}

	elgg_clear_sticky_form('gameserver'); 
	

	return $values;
}
