<?php
/**
* Game Server Plugin
*/

elgg_register_event_handler ('init', 'system','gameserver_init');


function gameserver_init(){

	//copiado de init de likeskpax para registrar la librera kpaxSrv que reside en el plugin kpax
	
	$root = dirname(__FILE__);

    $root = str_replace("gameserver", "kpax", $root);


    elgg_register_library('elgg:kpaxSrv', "$root/lib/kpaxSrv.php");
    elgg_load_library('elgg:kpaxSrv');
	
	//fin de copiado

	elgg_register_page_handler('gameserver','gameserver_page_handler');
	
	$item = new ElggMenuItem('developers', 'Developers', 'gameserver/intro');
	elgg_register_menu_item('site',$item);
		
	elgg_register_menu_item('page', array(
	'name' => 'addgame',
	'text' => 'Add Game',
	'href' => 'gameserver/addgame',
	'context' => array ('gameserver'),
	));
	elgg_register_menu_item('page', array(
	'name' => 'mygames',
	'text' => 'My Games',
	'href' => 'gameserver/mygames',
	'context' => array ('gameserver'),
	));
	
	elgg_register_menu_item('page', array(
	'name' => 'admingames',
	'text' => 'All Games',					 //'Administraci&oacute;n de Juegos',
	'href' => 'gameserver/admingames',
	'context' => array ('gameserver'),
	));
	elgg_register_menu_item('page', array(
	'name' => 'delete',
	'text' => 'Delete Game',
	'href' => 'gameserver/delete',
	'context' => array ('gameserver'),
	));
	elgg_register_menu_item('page', array(
	'name' => 'edit',
	'text' => 'Edit Game',
	'href' => 'gameserver/editgame',
	'context' => array ('gameserver'),
	));
	
	//botones de editar y borrar juegos del formulario editgame.php
	
	elgg_register_menu_item('body', array(
                'name' => 'details',
                'href' => 'gameserver/gameitem',
                'text' => elgg_echo('gameserver:game:item:edit'),
                'link_class' => 'elgg-button elgg-button-action',
             ));
	elgg_register_menu_item('body', array(
                'name' => 'delete',
                'href' => 'gameserver/delete',
                'text' => elgg_echo('gameserver:game:item:delete'),
                'link_class' => 'elgg-button elgg-button-action',
             ));		 

//boton de salvar cambios en  juegos del formulario gameitem.php

	elgg_register_menu_item('body', array(
                'name' => 'savechanges',
                'href' => 'gameserver/savechanges',
                'text' => elgg_echo('gameserver:save:changes'),
                'link_class' => 'elgg-button elgg-button-action'
             ));	
		
//registramos las acciones:

$base = elgg_get_plugins_path() . 'gameserver/actions/gameserver';
// dar de alta juegos
elgg_register_action("gameserver/save", "$base/save.php","logged_in");
//borrar juegos
elgg_register_action("gameserver/delete", "$base/delete.php","logged_in");
//salvar cambios en  juegos
elgg_register_action("gameserver/savechanges", "$base/savechanges.php","logged_in");

//mostrar detalles de  un slo juego
elgg_register_action("gameserver/gameitem", "$base/gameitem.php","logged_in");

//extendemos la vista por defecto. Solo afecta a tablas 
//elgg_extend_view('css/elgg', 'gameserver/css');
elgg_extend_view('gameserver/admingames', 'gameserver/tablesorter');
elgg_extend_view('page/elements/head','gameserver/metatags');


// registramos la libreria /lib/gamehelp.php copiada de lib/kpax.php
$lib = elgg_get_plugins_path() . 'gameserver/lib/gamehelp.php';
elgg_register_library('gameserver',$lib);
elgg_load_library('gameserver');

// Registramos el plugin javascript necesario para ordenar las tablas
	$url_base = 'mod/gameserver/vendors/jquery-tablesorter/';
	$tsorter = $url_base . 'jquery.tablesorter.min.js';
	$jquery = $url_base . 'jquery-latest.js';
		
	elgg_register_js('jquery-latest', $jquery , 'footer');
	elgg_register_js('jquery-tablesorter', $tsorter, 'footer');

	
	$css_url = 'mod/gameserver/vendors/jquery-tablesorter/themes/blue/style.css';
	elgg_register_css('jquery-tablesorter', $css_url);
	elgg_load_js('jquery-tablesorter');
	elgg_load_js('jquery-latest');
	elgg_load_css('jquery-tablesorter');

		
elgg_extend_view('js/elgg','gameserver/js');
elgg_extend_view('css/elgg', 'gameserver/css');


}

function gameserver_page_handler($page, $identifier){
$plugin_path = elgg_get_plugins_path();
$base_path = $plugin_path . 'gameserver/pages/gameserver';

switch ($page[0]) {
	case 'intro':
		require "$base_path/intro.php";
		break;
	case 'admingames':
		require "$base_path/admingames.php";
		break;
	case 'addgame':
		require "$base_path/addgame.php";
		break;
	case 'mygames':
		require "$base_path/mygames.php";
		break;
	case 'gameitem':
		require "$base_path/gameitem.php";
		break;
	case 'delete':
		require "$base_path/delete.php";
		break;
	case 'editgame':
		require "$base_path/editgame.php";
		break;
	default;
		echo "peticion para $identifier $page[0]";
		break;
}
	return true;
	
}
?>